This document lists the P. falciparum genes in the analysis, gives the rationale for their inclusion and links to the literature. 



Gene                    | Reason included  | Paper/doi     | Stage
:----------:            | :--------------: | :----:    | :---:
HRP2 (PF3D7_0831800)    |        3         |  [1][1]
HRP3 (PF3D7_1372200)    |        3         |  [1][1]
DBLMSP (PF3D7_1035700)  |      1;4         |  [2][2]  |  Merozoite
DBLMSP2 (PF3D7_1036300) |      1;4         |  [2][2],[3][3]   | Merozoite
SURF4.2 (PF3D7_0424400) |        1         |  [2][2]  |
LSA1 (PF3D7_1036400)    |      2;4         |  [4][4]  | Liver
LSA3 (PF3D7_0220000)    |        4         |  |
CSP (PF3D7_0304600)     |      2;4         |  [4][4],[5][5]  | Sporozoite
MSP1 (PF3D7_0930300)    |      2;4         |  [4][4],[5][5] | Merozoite
MSP2 (PF3D7_0206800)    |        4         |   |  Merozoite
MSP3 (PF3D7_1035400)    |        2         | [4][4],[5][5] | Merozoite
MSP4 (PF3D7_0207000)    |        2         | [4][4] | Merozoite
MSP5 (PF3D7_0206900)    |        2         | [4][4] | Merozoite
MSP6 (PF3D7_1035500)    |        2         | [5][5] | Merozoite
MSP7 (PF3D7_1335100)    |        2         |[5][5] | Merozoite
TRAP (PF3D7_1335900)    |        2         | [4][4],[5][5] | Sporozoite
AMA1 (PF3D7_1133400)    |        2         | [4][4],[5][5] | Merozoite
RAMA (PF3D7_0707300)    |        2         | [5][5] | 
EBA175 (PF3D7_0731500)  |        2         | [4][4],[5][5] | 
RH5 (PF3D7_0424100)     |        2         | [5][5],[6][6] | Merozoite
GLURP (Pf7G8_100039600) |        2         | [4][4],[5][5] | Merozoite
SERA5 (PF3D7_0207600)   |        2         | [5][5]  | Merozoite
CelTOS (PF3D7_1216600)  |        2         | [5][5]  | Liver
P48/45 (PF3D7_1346700)  |        2         | [4][4],[5][5] | Gametocyte
Pfs25 (PF3D7_1030900)   |        2         | [5][5]

Genes that could further be added:

Gene                    | Reason included  | Paper/doi     | Stage
:----------:            | :--------------: | :----:    | :---:
Pf38                    |        2         | [6][6]        | Merozoite


## List of *reason included* codes referred to in the gene table

Code   | Explanation
:----: | :------------:
1      | Gene is under balancing selection/dimorphic
2      | Gene is candidate vaccine target
3      | Gene is used in rapid diagnostic testing
4      | Gene was not successfully variant called by collaborators in the Barry lab using GATK pipeline

## List of *Paper/doi* codes linked to in the gene table


* [[1]][1]: Ahouidi et al 2021, An open dataset of Plasmodium falciparum genome variation in 7,000 worldwide samples
* [[2]][2]: Ochola et al 2010: Allele Frequency–Based and Polymorphism-Versus-
Divergence Indices of Balancing Selection in a New Filtered
Set of Polymorphic Genes in Plasmodium falciparum
* [[3]][3]: Amambua-Ngwa et al 2012, Population Genomic Scan for Candidate Signatures of Balancing Selection to Guide Antigen Characterization in Malaria Parasites
* [[4]][4]: Barry et al 2009, Contrasting Population Structures of the Genes Encoding Ten Leading Vaccine-Candidate Antigens of the Human Malaria Parasite, Plasmodium falciparum. 
* [[5]][5]: Beeson et al 2019, Challenges and strategies for developing efficacious and long-lasting malaria vaccines
* [[6]][6]: Douglas et al 2011, The blood-stage malaria antigen PfRH5 is susceptible to vaccine-inducible cross-strain neutralizing antibody

[1]: https://wellcomeopenresearch.org/articles/6-42/v1
[2]: https://academic.oup.com/mbe/article/27/10/2344/967205
[3]: https://journals.plos.org/plosgenetics/article?id=10.1371/journal.pgen.1002992
[4]: https://journals.plos.org/plosone/article?id=10.1371/journal.pone.0008497
[5]: https://stm.sciencemag.org/content/11/474/eaau1458
[6]: https://www.nature.com/articles/ncomms1615


## Other important papers/links

* WHO Tables of malaria vaccine projects globally ('Rainbow Table'): http://www.who.int/immunization/research/development/Rainbow_tables/en/
